﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
//using System.IO;
using System.Net.NetworkInformation; 
using System.Management;
using System.Windows.Forms;
using System.Runtime.InteropServices;  //api
using System.Net.Sockets;

namespace Ethernet_data
{
    class Class3
    {
        [DllImport("ws2_32.dll")]
        private static extern int inet_addr(string cp);
        [DllImport("IPHLPAPI.dll")]
        private static extern int SendARP(Int32 DestIP, Int32 SrcIP, ref Int64 pMacAddr, ref Int32 PhyAddrLen);


        public static bool getNetwork(ref string[,] list,ref int index)
        {
            if (NetworkInterface.GetIsNetworkAvailable())
            {
                NetworkInterface[] adapters = NetworkInterface.GetAllNetworkInterfaces();
                foreach (NetworkInterface adapter in adapters)
                {
                    IPInterfaceProperties ipProperties = adapter.GetIPProperties();//获取IP配置
                    UnicastIPAddressInformationCollection ipCollection = ipProperties.UnicastAddresses;//获取单播地址集
                    foreach (UnicastIPAddressInformation ip in ipCollection)
                    {
                        try
                        {
                            if (ip.Address.AddressFamily == AddressFamily.InterNetwork)//只要ipv4的
                            {

                                list[index,0] = ip.Address.ToString();
                                list[index,1] = ip.IPv4Mask.ToString();
                                foreach (GatewayIPAddressInformation Gateaddress in ipProperties.GatewayAddresses)
                                {

                                    if (Gateaddress.Address.AddressFamily == AddressFamily.InterNetwork)
                                        list[index,2] = Gateaddress.Address.ToString();
                                }
                                list[index, 3] = adapter.Name + " [" + adapter.Description + " " + adapter.NetworkInterfaceType+"]";

                                index++;
                            }
                        }
                        catch { }
                    }
                }
                return true;
            }
            return false;
        }
        public static string ScanTarget(string ip)
        {
            string strIPAddress = ip;
            int nStrat = Int32.Parse("2");
            int nEnd = Int32.Parse("254");
            for (int i = nStrat; i <= nEnd; i++)
            {
                try
                {
                    Int32 ldest = inet_addr(strIPAddress + "." + i); //将IP地址从 点数格式转换成无符号长整型
                    Int64 macinfo = new Int64();
                    Int32 len = 6;
                    SendARP(ldest, 0, ref macinfo, ref len);
                    if (macinfo == 0)  return strIPAddress + "." + i;
                }
                catch { }
            }
            return null;
        }
    }
}
